package com.fzm.common.service.impl;

import com.fzm.common.entity.Order;
import com.fzm.common.entity.User;
import com.fzm.common.service.OrderService;
import com.fzm.common.service.SmsService;
import com.fzm.common.service.UserService;
import com.fzm.common.utils.SmsUtil;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;

/**
 * @author tangtuo
 * @date 2022/2/8 14:12
 */
@Service
public class SmsServiceImpl implements SmsService {

    @Resource
    private UserService userService;

    @Resource
    private SmsUtil smsUtil;

    @Resource
    private OrderService orderService;

    @Override
    @Async("threadPoolTaskExecutor")
    public void sendRefundSms(Long orderId) {
        Order order = orderService.getById(orderId);
        User user = userService.getById(order.getUserId());
        String fee = BigDecimal.valueOf(order.getFee()).divide(new BigDecimal(100), 2, BigDecimal.ROUND_DOWN).toString();
        smsUtil.sendRefundSms(user.getTelephone(), fee);
    }
}
