package com.fzm.portal;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fzm.common.properties.WxPayProperties;
import com.fzm.common.service.WxPayService;
import com.fzm.common.utils.SnowflakeUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.junit.jupiter.api.Test;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

/**
 * @author tangtuo
 * @date 2022/1/13 15:30
 */
@Slf4j
@SpringBootTest
public class WxPayTest {


    @Resource
    private CloseableHttpClient httpClient;

    @Resource
    private WxPayProperties wxPayProperties;

    @Resource
    private WxPayService wxPayService;

    @Resource
    private SnowflakeUtil snowflakeUtil;

    @Resource
    private RabbitTemplate rabbitTemplate;

    @Test
    public void testSnowFlake() {
        for (int i = 0; i < 10; i++) {
            log.info(String.valueOf(snowflakeUtil.snowflakeId()));
        }
    }

    @Test
    public void testH5Pay() throws IOException {
//        OrderProcessMsg orderProcessMsg = new OrderProcessMsg(1, 1);
//        rabbitTemplate.convertAndSend("order-exchange", "order.process", orderProcessMsg);
//        for (int i = 0; i < 10; i++) {
//            log.info(String.valueOf(snowflakeUtil.snowflakeId()));//       }
//        String url = "https://api.mch.weixin.qq.com/v3/pay/transactions/jsapi";
//        HttpPost httpPost = new HttpPost(url);
//        httpPost.addHeader("Accept", "application/json");
//        httpPost.addHeader("Content-type", "application/json; charset=utf-8");
//        ByteArrayOutputStream bos = new ByteArrayOutputStream();
//        ObjectMapper objectMapper = new ObjectMapper();
//
//        ObjectNode rootNode = objectMapper.createObjectNode();
//        rootNode.put("mchid", wxPayProperties.getMchId())
//                .put("appid", wxPayProperties.getAppId())
//                .put("description", "Image形象店-深圳腾大-QQ公仔")
//                .put("notify_url", "http://www.baidu.com")
//                .put("out_trade_no", "nft-123");
//        rootNode.putObject("amount")
//                .put("total", 1);
//        rootNode.putObject("payer")
//                .put("openid", "oRpMVw3OiOuVDZPrJTzMwTJALf70");
//        String json = objectMapper.writeValueAsString(rootNode);
//        System.out.println("json = " + json);
//        objectMapper.writeValue(bos, rootNode);
//
//        httpPost.setEntity(new StringEntity(bos.toString("UTF-8"), "UTF-8"));
//        CloseableHttpResponse response = httpClient.execute(httpPost);
//
//        String bodyAsString = EntityUtils.toString(response.getEntity());
//        System.out.println(bodyAsString);
//
//        String data = "wx8888888888888888\n1414561699\n5K8264ILTKCH16CQ2502SI8ZNMTM67VS\nprepay_id=wx201410272009395522657a690389285100";
//        try {
//            System.out.println(wxPayService.encryptByPrivateKey(data));
//        } catch (Exception e) {
//            e.printStackTrace();
//        }

    }


    @Test
    void test() {
        String prepay_id = "wx181704295362907bc91140bfb2a71b0000";

        String url = "https://api.mch.weixin.qq.com/v3/pay/transactions/jsapi";
        HttpPost httpPost = new HttpPost(url);
        httpPost.addHeader("Accept", "application/json");
        httpPost.addHeader("Content-type", "application/json; charset=utf-8");
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        ObjectMapper objectMapper = new ObjectMapper();

        ObjectNode rootNode = objectMapper.createObjectNode();
        rootNode.put("mchid", wxPayProperties.getMchId())
                .put("appid", wxPayProperties.getAppId())
                .put("description", "Image形象店-深圳腾大-QQ公仔")
                .put("notify_url", "http://www.baidu.com")
                .put("out_trade_no", "nft-123");
    }


}
